exchange/src/auditor/generate-revoke-basedb.sh

610 lines
20 KiB
Bash
Raw Normal View History

2020-03-26 17:21:41 +01:00
#!/bin/bash
# Script to test revocation.
#
# Requires the wallet CLI to be installed and in the path. Furthermore, the
# user running this script must be Postgres superuser and be allowed to
# create/drop databases.
#
2022-09-23 16:21:52 +02:00
set -eu
# set -x
2020-03-26 17:21:41 +01:00
2020-08-28 18:30:44 +02:00
# Cleanup to run whenever we exit
2022-09-21 18:04:34 +02:00
function exit_cleanup()
2020-08-28 18:30:44 +02:00
{
2022-09-21 18:04:34 +02:00
echo "Running generate-revoke-basedb exit cleanup logic..."
2022-09-22 21:37:26 +02:00
if test -f ${MY_TMP_DIR:-/}/libeufin-sandbox.pid
2022-09-12 11:33:56 +02:00
then
2022-09-22 21:37:26 +02:00
PID=`cat ${MY_TMP_DIR}/libeufin-sandbox.pid 2> /dev/null`
2022-09-21 18:04:34 +02:00
kill $PID 2> /dev/null || true
2022-09-22 21:37:26 +02:00
rm ${MY_TMP_DIR}/libeufin-sandbox.pid
2022-09-21 18:04:34 +02:00
echo "Killed libeufin sandbox $PID"
wait $PID || true
2022-09-12 11:33:56 +02:00
fi
2022-09-22 21:37:26 +02:00
if test -f ${MY_TMP_DIR}/libeufin-nexus.pid
2022-09-12 11:33:56 +02:00
then
2022-09-22 21:37:26 +02:00
PID=`cat ${MY_TMP_DIR}/libeufin-nexus.pid 2> /dev/null`
2022-09-21 18:04:34 +02:00
kill $PID 2> /dev/null || true
2022-09-22 21:37:26 +02:00
rm ${MY_TMP_DIR}/libeufin-nexus.pid
2022-09-21 18:04:34 +02:00
echo "Killed libeufin nexus $PID"
wait $PID || true
2022-09-12 11:33:56 +02:00
fi
2022-09-21 18:04:34 +02:00
echo "killing libeufin DONE"
for n in `jobs -p`
do
kill $n 2> /dev/null || true
done
wait
2020-08-28 18:30:44 +02:00
}
2020-03-27 18:10:59 +01:00
2022-08-06 13:25:54 +02:00
function get_payto_uri() {
export LIBEUFIN_SANDBOX_USERNAME=$1
export LIBEUFIN_SANDBOX_PASSWORD=$2
export LIBEUFIN_SANDBOX_URL=$BANK_URL
2022-09-22 21:37:26 +02:00
cd $MY_TMP_DIR
2022-08-06 13:25:54 +02:00
libeufin-cli sandbox demobank info --bank-account $1 | jq --raw-output '.paytoUri'
2022-09-22 21:37:26 +02:00
cd $ORIGIN
2022-08-06 13:25:54 +02:00
}
2020-08-28 18:30:44 +02:00
# Install cleanup handler (except for kill -9)
2022-09-21 18:04:34 +02:00
trap exit_cleanup EXIT
2020-03-27 18:10:59 +01:00
2020-03-26 17:21:41 +01:00
# Exit, with status code "skip" (no 'real' failure)
function exit_skip() {
echo $1
exit 77
}
# Where do we write the result?
export BASEDB=${1:-"revoke-basedb"}
# Name of the Postgres database we will use for the script.
# Will be dropped, do NOT use anything that might be used
# elsewhere
2022-03-17 14:16:19 +01:00
export TARGET_DB=`basename ${BASEDB}`
2020-03-26 17:21:41 +01:00
TMP_DIR=`mktemp -d revocation-tmp-XXXXXX`
export WALLET_DB=wallet-revocation.json
rm -f $WALLET_DB
2020-03-31 20:57:11 +02:00
# Configuration file will be edited, so we create one
2020-03-26 17:21:41 +01:00
# from the template.
2022-08-23 20:40:26 +02:00
export CONF=${BASEDB}.conf
2022-03-17 14:16:19 +01:00
cp generate-auditor-basedb.conf $CONF
2022-09-19 19:32:18 +02:00
echo "Created configuration at ${CONF}"
2022-09-22 21:37:26 +02:00
DATA_DIR=$1/exchange-data-dir/
mkdir -p $DATA_DIR
taler-config -c $CONF -s PATHS -o TALER_HOME -V $DATA_DIR
2020-03-26 17:21:41 +01:00
2022-08-06 13:25:54 +02:00
echo -n "Testing for libeufin(-cli)"
libeufin-cli --help >/dev/null </dev/null || exit_skip " MISSING"
2020-03-26 17:21:41 +01:00
echo " FOUND"
echo -n "Testing for taler-wallet-cli"
taler-wallet-cli -v >/dev/null </dev/null || exit_skip " MISSING"
echo " FOUND"
2022-03-14 16:03:01 +01:00
echo -n "Testing for curl"
curl --help >/dev/null </dev/null || exit_skip " MISSING"
echo " FOUND"
2020-03-26 17:21:41 +01:00
# reset database
dropdb $TARGET_DB >/dev/null 2>/dev/null || true
createdb $TARGET_DB || exit_skip "Could not create database $TARGET_DB"
2022-09-22 21:37:26 +02:00
ORIGIN=`pwd`
MY_TMP_DIR=`dirname $1`
2020-03-26 17:21:41 +01:00
# obtain key configuration data
2022-09-19 19:32:18 +02:00
MASTER_PRIV_FILE=$1.mpriv
2020-03-26 17:21:41 +01:00
MASTER_PRIV_DIR=`dirname $MASTER_PRIV_FILE`
2022-09-19 19:32:18 +02:00
taler-config -f -c $CONF -s exchange-offline -o MASTER_PRIV_FILE -V ${MASTER_PRIV_FILE}
2020-03-26 17:21:41 +01:00
mkdir -p $MASTER_PRIV_DIR
2022-08-23 20:40:26 +02:00
rm -f "${MASTER_PRIV_FILE}"
2020-03-26 17:21:41 +01:00
gnunet-ecc -g1 $MASTER_PRIV_FILE > /dev/null
export MASTER_PUB=`gnunet-ecc -p $MASTER_PRIV_FILE`
export EXCHANGE_URL=`taler-config -c $CONF -s EXCHANGE -o BASE_URL`
MERCHANT_PORT=`taler-config -c $CONF -s MERCHANT -o PORT`
export MERCHANT_URL=http://localhost:${MERCHANT_PORT}/
BANK_PORT=`taler-config -c $CONF -s BANK -o HTTP_PORT`
2022-08-06 13:25:54 +02:00
export BANK_URL=http://localhost:1${BANK_PORT}/demobanks/default
2020-03-26 17:21:41 +01:00
export AUDITOR_URL=http://localhost:8083/
2022-09-19 19:32:18 +02:00
AUDITOR_PRIV_FILE=$1.apriv
2020-12-16 14:16:02 +01:00
AUDITOR_PRIV_DIR=`dirname $AUDITOR_PRIV_FILE`
2022-09-19 19:32:18 +02:00
taler-config -f -c ${CONF} -s auditor -o AUDITOR_PRIV_FILE -V ${AUDITOR_PRIV_FILE}
2020-12-16 14:16:02 +01:00
mkdir -p $AUDITOR_PRIV_DIR
2022-09-19 19:32:18 +02:00
gnunet-ecc -l /dev/null -g1 $AUDITOR_PRIV_FILE > /dev/null
AUDITOR_PUB=`gnunet-ecc -p $AUDITOR_PRIV_FILE`
2020-03-26 17:21:41 +01:00
2022-09-19 19:32:18 +02:00
echo "MASTER PUB is ${MASTER_PUB} using file ${MASTER_PRIV_FILE}"
echo "AUDITOR PUB is ${AUDITOR_PUB} using file ${AUDITOR_PRIV_FILE}"
2020-03-26 17:21:41 +01:00
# patch configuration
taler-config -c $CONF -s exchange -o MASTER_PUBLIC_KEY -V $MASTER_PUB
2022-09-19 19:32:18 +02:00
taler-config -c $CONF -s auditor -o PUBLIC_KEY -V $AUDITOR_PUB
2020-03-26 17:21:41 +01:00
taler-config -c $CONF -s merchant-exchange-default -o MASTER_KEY -V $MASTER_PUB
taler-config -c $CONF -s exchangedb-postgres -o CONFIG -V postgres:///$TARGET_DB
taler-config -c $CONF -s auditordb-postgres -o CONFIG -V postgres:///$TARGET_DB
taler-config -c $CONF -s merchantdb-postgres -o CONFIG -V postgres:///$TARGET_DB
taler-config -c $CONF -s bank -o database -V postgres:///$TARGET_DB
taler-config -c $CONF -s exchange -o KEYDIR -V "${TMP_DIR}/keydir/"
taler-config -c $CONF -s exchange -o REVOCATION_DIR -V "${TMP_DIR}/revdir/"
# setup exchange
echo "Setting up exchange"
taler-exchange-dbinit -c $CONF
2021-01-06 11:34:50 +01:00
echo "Setting up merchant"
taler-merchant-dbinit -c $CONF
2020-03-26 17:21:41 +01:00
# setup auditor
echo "Setting up auditor"
taler-auditor-dbinit -c $CONF
taler-auditor-exchange -c $CONF -m $MASTER_PUB -u $EXCHANGE_URL
2020-03-26 17:21:41 +01:00
# Launch services
echo "Launching services"
2022-09-21 18:04:34 +02:00
export LIBEUFIN_SANDBOX_DB_CONNECTION="jdbc:sqlite:${TARGET_DB}-sandbox.sqlite3"
# Create the default demobank.
2022-09-22 21:37:26 +02:00
cd $MY_TMP_DIR
2022-09-21 18:04:34 +02:00
libeufin-sandbox config --currency "TESTKUDOS" default
export LIBEUFIN_SANDBOX_ADMIN_PASSWORD=secret
libeufin-sandbox serve --port "1${BANK_PORT}" \
2022-09-22 21:37:26 +02:00
> ${MY_TMP_DIR}/libeufin-sandbox-stdout.log \
2> ${MY_TMP_DIR}/libeufin-sandbox-stderr.log &
echo $! > ${MY_TMP_DIR}/libeufin-sandbox.pid
cd $ORIGIN
2022-09-21 18:04:34 +02:00
export LIBEUFIN_SANDBOX_URL="http://localhost:1${BANK_PORT}/demobanks/default"
set +e
echo -n "Waiting for Sandbox..."
OK=0
for n in `seq 1 50`; do
echo -n "."
sleep 1
if wget --timeout=1 \
--tries=3 --waitretry=0 \
-o /dev/null -O /dev/null \
$LIBEUFIN_SANDBOX_URL;
then
OK=1
break
fi
done
if test $OK != 1
then
exit_skip " Failed to launch sandbox"
fi
echo "OK"
register_sandbox_account() {
export LIBEUFIN_SANDBOX_USERNAME=$1
export LIBEUFIN_SANDBOX_PASSWORD=$2
2022-09-22 21:37:26 +02:00
cd $MY_TMP_DIR
2022-09-21 18:04:34 +02:00
libeufin-cli sandbox \
demobank \
register --name "$3"
2022-09-22 21:37:26 +02:00
cd $ORIGIN
2022-09-21 18:04:34 +02:00
unset LIBEUFIN_SANDBOX_USERNAME
unset LIBEUFIN_SANDBOX_PASSWORD
}
set -e
echo -n "Register the 'fortytwo' Sandbox user.."
register_sandbox_account fortytwo x "Forty Two"
echo OK
echo -n "Register the 'fortythree' Sandbox user.."
register_sandbox_account fortythree x "Forty Three"
echo OK
echo -n "Register 'exchange' Sandbox user.."
register_sandbox_account exchange x "Exchange Company"
echo OK
echo -n "Specify exchange's PAYTO_URI in the config ..."
export LIBEUFIN_SANDBOX_USERNAME=exchange
export LIBEUFIN_SANDBOX_PASSWORD=x
2022-09-22 21:37:26 +02:00
cd $MY_TMP_DIR
2022-09-21 18:04:34 +02:00
PAYTO=`libeufin-cli sandbox demobank info --bank-account exchange | jq --raw-output '.paytoUri'`
taler-config -c $CONF -s exchange-account-1 -o PAYTO_URI -V $PAYTO
echo " OK"
echo -n "Setting this exchange as the bank's default ..."
EXCHANGE_PAYTO=`libeufin-cli sandbox demobank info --bank-account exchange | jq --raw-output '.paytoUri'`
libeufin-sandbox default-exchange "$EXCHANGE_URL" "$EXCHANGE_PAYTO"
echo " OK"
# Prepare EBICS: create Ebics host and Exchange subscriber.
# Shortly becoming admin to setup Ebics.
export LIBEUFIN_SANDBOX_USERNAME=admin
export LIBEUFIN_SANDBOX_PASSWORD=secret
echo -n "Create EBICS host at Sandbox.."
libeufin-cli sandbox \
--sandbox-url "http://localhost:1${BANK_PORT}" \
ebicshost create --host-id "talerebics"
echo "OK"
echo -n "Create exchange EBICS subscriber at Sandbox.."
libeufin-cli sandbox \
demobank new-ebicssubscriber --host-id talerebics \
--user-id exchangeebics --partner-id talerpartner \
--bank-account exchange # that's a username _and_ a bank account name
echo "OK"
unset LIBEUFIN_SANDBOX_USERNAME
unset LIBEUFIN_SANDBOX_PASSWORD
# Prepare Nexus, which is the side actually talking
# to the exchange.
export LIBEUFIN_NEXUS_DB_CONNECTION="jdbc:sqlite:${TARGET_DB}-nexus.sqlite3"
# For convenience, username and password are
# identical to those used at the Sandbox.
echo -n "Create exchange Nexus user..."
libeufin-nexus superuser exchange --password x
echo " OK"
libeufin-nexus serve --port ${BANK_PORT} \
2022-09-22 21:37:26 +02:00
2> ${MY_TMP_DIR}/libeufin-nexus-stderr.log \
> ${MY_TMP_DIR}/libeufin-nexus-stdout.log &
echo $! > ${MY_TMP_DIR}/libeufin-nexus.pid
2022-09-21 18:04:34 +02:00
export LIBEUFIN_NEXUS_URL="http://localhost:${BANK_PORT}"
echo -n "Waiting for Nexus..."
set +e
OK=0
for n in `seq 1 50`; do
echo -n "."
sleep 1
if wget --timeout=1 \
--tries=3 --waitretry=0 \
-o /dev/null -O /dev/null \
$LIBEUFIN_NEXUS_URL;
then
OK=1
break
fi
done
if test $OK != 1
then
exit_skip " Failed to launch Nexus at $LIBEUFIN_NEXUS_URL"
fi
set -e
echo "OK"
export LIBEUFIN_NEXUS_USERNAME=exchange
export LIBEUFIN_NEXUS_PASSWORD=x
echo -n "Creating an EBICS connection at Nexus..."
libeufin-cli connections new-ebics-connection \
--ebics-url "http://localhost:1${BANK_PORT}/ebicsweb" \
--host-id "talerebics" \
--partner-id "talerpartner" \
--ebics-user-id "exchangeebics" \
talerconn
echo "OK"
echo -n "Setup EBICS keying..."
libeufin-cli connections connect "talerconn" > /dev/null
echo "OK"
echo -n "Download bank account name from Sandbox..."
libeufin-cli connections download-bank-accounts "talerconn"
echo "OK"
echo -n "Importing bank account info into Nexus..."
libeufin-cli connections import-bank-account \
--offered-account-id "exchange" \
--nexus-bank-account-id "exchange-nexus" \
"talerconn"
echo "OK"
echo -n "Setup payments submission task..."
# Tries every second.
libeufin-cli accounts task-schedule \
--task-type submit \
--task-name "exchange-payments" \
--task-cronspec "* * *" \
"exchange-nexus"
echo "OK"
# Tries every second. Ask C52
echo -n "Setup history fetch task..."
libeufin-cli accounts task-schedule \
--task-type fetch \
--task-name "exchange-history" \
--task-cronspec "* * *" \
--task-param-level report \
--task-param-range-type latest \
"exchange-nexus"
echo "OK"
# create Taler facade.
echo -n "Create the Taler facade at Nexus..."
libeufin-cli facades \
new-taler-wire-gateway-facade \
--currency "TESTKUDOS" --facade-name "test-facade" \
"talerconn" "exchange-nexus"
echo "OK"
2022-09-22 21:37:26 +02:00
cd $ORIGIN
2022-09-21 18:04:34 +02:00
# Facade schema: http://localhost:$BANK_PORT/facades/test-facade/taler-wire-gateway/
2020-12-14 15:42:32 +01:00
TFN=`which taler-exchange-httpd`
TBINPFX=`dirname $TFN`
TLIBEXEC=${TBINPFX}/../lib/taler/libexec/
2022-09-22 21:37:26 +02:00
taler-exchange-secmod-eddsa -c $CONF 2> ${MY_TMP_DIR}/taler-exchange-secmod-eddsa.log &
SIGNKEY_HELPER_PID=$!
2022-09-22 21:37:26 +02:00
taler-exchange-secmod-rsa -c $CONF 2> ${MY_TMP_DIR}/taler-exchange-secmod-rsa.log &
RSA_DENOM_HELPER_PID=$!
2022-09-22 21:37:26 +02:00
taler-exchange-secmod-cs -c $CONF 2> ${MY_TMP_DIR}/taler-exchange-secmod-cs.log &
CS_DENOM_HELPER_PID=$!
2022-09-22 21:37:26 +02:00
taler-exchange-httpd -c $CONF 2> ${MY_TMP_DIR}/taler-exchange-httpd.log &
2020-03-26 17:21:41 +01:00
EXCHANGE_PID=$!
2022-09-22 21:37:26 +02:00
taler-merchant-httpd -c $CONF -L INFO 2> ${MY_TMP_DIR}/taler-merchant-httpd.log &
2020-03-26 18:58:42 +01:00
MERCHANT_PID=$!
2022-09-22 21:37:26 +02:00
taler-exchange-wirewatch -c $CONF 2> ${MY_TMP_DIR}/taler-exchange-wirewatch.log &
taler-auditor-httpd -c $CONF 2> ${MY_TMP_DIR}/taler-auditor-httpd.log &
2020-03-26 17:21:41 +01:00
# Wait for all bank to be available (usually the slowest)
for n in `seq 1 50`
do
echo -n "."
sleep 0.2
OK=0
# bank
wget http://localhost:8082/ -o /dev/null -O /dev/null >/dev/null || continue
OK=1
break
done
if [ 1 != $OK ]
then
2022-03-17 14:16:19 +01:00
exit_skip "Failed to launch Bank services"
fi
2020-03-26 17:21:41 +01:00
# Wait for all other services to be available
for n in `seq 1 50`
do
echo -n "."
sleep 0.1
OK=0
# exchange
wget http://localhost:8081/seed -o /dev/null -O /dev/null >/dev/null || continue
2020-03-26 17:21:41 +01:00
# merchant
wget http://localhost:9966/ -o /dev/null -O /dev/null >/dev/null || continue
# Auditor
wget http://localhost:8083/ -o /dev/null -O /dev/null >/dev/null || continue
OK=1
break
done
if [ 1 != $OK ]
then
2022-09-21 18:04:34 +02:00
exit_cleanup
2022-03-17 14:16:19 +01:00
exit_skip "Failed to launch Taler services"
2020-03-26 17:21:41 +01:00
fi
echo " DONE"
echo -n "Setting up keys"
taler-exchange-offline -c $CONF \
download sign \
2022-08-06 13:25:54 +02:00
enable-account `taler-config -c $CONF -s exchange-account-1 -o PAYTO_URI` \
enable-auditor $AUDITOR_PUB $AUDITOR_URL "TESTKUDOS Auditor" \
2022-08-06 13:25:54 +02:00
wire-fee now iban TESTKUDOS:0.01 TESTKUDOS:0.01 TESTKUDOS:0.01 \
2022-03-14 16:03:01 +01:00
global-fee now TESTKUDOS:0.01 TESTKUDOS:0.01 TESTKUDOS:0.01 TESTKUDOS:0.01 1h 1h 1year 5 \
2022-09-22 21:37:26 +02:00
upload &> ${MY_TMP_DIR}/taler-exchange-offline.log
echo -n "."
for n in `seq 1 2`
do
echo -n "."
OK=0
# bank
wget --timeout=1 http://localhost:8081/keys -o /dev/null -O /dev/null >/dev/null || continue
OK=1
break
done
if [ 1 != $OK ]
then
exit_skip "Failed to setup keys"
fi
taler-auditor-offline -c $CONF \
2022-09-22 21:37:26 +02:00
download sign upload &> ${MY_TMP_DIR}/taler-auditor-offline.log
echo " DONE"
2020-08-28 18:30:44 +02:00
# Setup merchant
echo -n "Setting up merchant"
2020-08-28 18:30:44 +02:00
2022-08-06 14:25:49 +02:00
curl -H "Content-Type: application/json" -X POST -d '{"auth": {"method": "external"}, "payto_uris":["payto://iban/SANDBOXX/DE474361?receiver-name=Merchant43"],"id":"default","name":"default","address":{},"jurisdiction":{},"default_max_wire_fee":"TESTKUDOS:1", "default_max_deposit_fee":"TESTKUDOS:1","default_wire_fee_amortization":1,"default_wire_transfer_delay":{"d_us" : 3600000000},"default_pay_delay":{"d_us": 3600000000}}' http://localhost:9966/management/instances
2020-08-28 18:30:44 +02:00
2020-03-26 17:21:41 +01:00
# run wallet CLI
echo "Running wallet"
2020-08-14 13:19:17 +02:00
taler-wallet-cli --no-throttle --wallet-db=$WALLET_DB api --expect-success 'withdrawTestBalance' \
2020-08-14 13:19:17 +02:00
"$(jq -n '
{
amount: "TESTKUDOS:8",
bankBaseUrl: $BANK_URL,
2020-08-14 13:22:29 +02:00
exchangeBaseUrl: $EXCHANGE_URL,
2020-08-14 13:19:17 +02:00
}' \
2022-08-06 13:25:54 +02:00
--arg BANK_URL "$BANK_URL/access-api/" \
2020-08-14 13:19:17 +02:00
--arg EXCHANGE_URL $EXCHANGE_URL
)"
2020-03-26 17:21:41 +01:00
taler-wallet-cli --no-throttle --wallet-db=$WALLET_DB run-until-done
2020-03-26 17:21:41 +01:00
export coins=$(taler-wallet-cli --wallet-db=$WALLET_DB advanced dump-coins)
2020-08-28 20:17:24 +02:00
echo -n "COINS are:"
echo $coins
2020-03-26 17:21:41 +01:00
# Find coin we want to revoke
export rc=$(echo "$coins" | jq -r '[.coins[] | select((.denom_value == "TESTKUDOS:2"))][0] | .coin_pub')
# Find the denom
export rd=$(echo "$coins" | jq -r '[.coins[] | select((.denom_value == "TESTKUDOS:2"))][0] | .denom_pub_hash')
echo "Revoking denomination ${rd} (to affect coin ${rc})"
# Find all other coins, which will be suspended
export susp=$(echo "$coins" | jq --arg rc "$rc" '[.coins[] | select(.coin_pub != $rc) | .coin_pub]')
# Do the revocation
taler-exchange-offline -c $CONF \
2022-09-22 21:37:26 +02:00
revoke-denomination "${rd}" upload &> ${MY_TMP_DIR}/taler-exchange-offline-revoke.log
sleep 1 # Give exchange time to create replacmenent key
2020-03-26 17:21:41 +01:00
2021-04-23 23:53:52 +02:00
# Re-sign replacement keys
taler-auditor-offline -c $CONF \
2022-09-22 21:37:26 +02:00
download sign upload &> ${MY_TMP_DIR}/taler-auditor-offline.log
2020-03-26 17:21:41 +01:00
# Now we suspend the other coins, so later we will pay with the recouped coin
taler-wallet-cli --wallet-db=$WALLET_DB advanced suspend-coins "$susp"
# Update exchange /keys so recoup gets scheduled
taler-wallet-cli --wallet-db=$WALLET_DB exchanges update \
-f $EXCHANGE_URL
# Block until scheduled operations are done
taler-wallet-cli --wallet-db=$WALLET_DB run-until-done
# Now we buy something, only the coins resulting from recouped will be
# used, as other ones are suspended
2020-08-14 12:48:58 +02:00
taler-wallet-cli --no-throttle --wallet-db=$WALLET_DB api 'testPay' \
"$(jq -n '
{
amount: "TESTKUDOS:1",
merchantBaseUrl: $MERCHANT_URL,
summary: "foo",
}' \
--arg MERCHANT_URL $MERCHANT_URL
)"
2020-03-26 17:21:41 +01:00
taler-wallet-cli --wallet-db=$WALLET_DB run-until-done
echo "Purchase with recoup'ed coin (via reserve) done"
# Find coin we want to refresh, then revoke
export rrc=$(echo "$coins" | jq -r '[.coins[] | select((.denom_value == "TESTKUDOS:5"))][0] | .coin_pub')
# Find the denom
export zombie_denom=$(echo "$coins" | jq -r '[.coins[] | select((.denom_value == "TESTKUDOS:5"))][0] | .denom_pub_hash')
echo "Will refresh coin ${rrc} of denomination ${zombie_denom}"
# Find all other coins, which will be suspended
export susp=$(echo "$coins" | jq --arg rrc "$rrc" '[.coins[] | select(.coin_pub != $rrc) | .coin_pub]')
export rrc
export zombie_denom
# Travel into the future! (must match DURATION_WITHDRAW option)
export TIMETRAVEL="--timetravel=604800000000"
echo "Launching exchange 1 week in the future"
kill -TERM $EXCHANGE_PID
kill -TERM $RSA_DENOM_HELPER_PID
kill -TERM $CS_DENOM_HELPER_PID
kill -TERM $SIGNKEY_HELPER_PID
2022-09-22 21:37:26 +02:00
taler-exchange-secmod-eddsa $TIMETRAVEL -c $CONF 2> ${MY_TMP_DIR}/taler-exchange-secmod-eddsa.log &
SIGNKEY_HELPER_PID=$!
2022-09-22 21:37:26 +02:00
taler-exchange-secmod-rsa $TIMETRAVEL -c $CONF 2> ${MY_TMP_DIR}/taler-exchange-secmod-rsa.log &
RSA_DENOM_HELPER_PID=$!
2022-09-22 21:37:26 +02:00
taler-exchange-secmod-cs $TIMETRAVEL -c $CONF 2> ${MY_TMP_DIR}/taler-exchange-secmod-cs.log &
CS_DENOM_HELPER_PID=$!
2022-09-22 21:37:26 +02:00
taler-exchange-httpd $TIMETRAVEL -c $CONF 2> ${MY_TMP_DIR}/taler-exchange-httpd.log &
2020-03-26 17:21:41 +01:00
export EXCHANGE_PID=$!
# Wait for exchange to be available
for n in `seq 1 50`
do
echo -n "."
sleep 0.1
OK=0
# exchange
wget http://localhost:8081/ -o /dev/null -O /dev/null >/dev/null || continue
OK=1
break
done
echo "Refreshing coin $rrc"
taler-wallet-cli $TIMETRAVEL --wallet-db=$WALLET_DB advanced force-refresh "$rrc"
taler-wallet-cli $TIMETRAVEL --wallet-db=$WALLET_DB run-until-done
# Update our list of the coins
export coins=$(taler-wallet-cli $TIMETRAVEL --wallet-db=$WALLET_DB advanced dump-coins)
# Find resulting refreshed coin
export freshc=$(echo "$coins" | jq -r --arg rrc "$rrc" \
'[.coins[] | select((.refresh_parent_coin_pub == $rrc) and .denom_value == "TESTKUDOS:0.1")][0] | .coin_pub'
)
2020-03-26 17:21:41 +01:00
# Find the denom of freshc
export fresh_denom=$(echo "$coins" | jq -r --arg rrc "$rrc" \
'[.coins[] | select((.refresh_parent_coin_pub == $rrc) and .denom_value == "TESTKUDOS:0.1")][0] | .denom_pub_hash'
)
2020-03-26 17:21:41 +01:00
echo "Coin ${freshc} of denomination ${fresh_denom} is the result of the refresh"
# Find all other coins, which will be suspended
export susp=$(echo "$coins" | jq --arg freshc "$freshc" '[.coins[] | select(.coin_pub != $freshc) | .coin_pub]')
# Do the revocation of freshc
echo "Revoking ${fresh_denom} (to affect coin ${freshc})"
taler-exchange-offline -c $CONF \
2022-09-22 21:37:26 +02:00
revoke-denomination "${fresh_denom}" upload &> ${MY_TMP_DIR}/taler-exchange-offline-revoke-2.log
2020-03-26 17:21:41 +01:00
sleep 1 # Give exchange time to create replacmenent key
2020-03-26 17:21:41 +01:00
2021-04-23 23:53:52 +02:00
# Re-sign replacement keys
taler-auditor-offline -c $CONF \
2022-09-22 21:37:26 +02:00
download sign upload &> ${MY_TMP_DIR}/taler-auditor-offline.log
2020-03-26 17:21:41 +01:00
# Now we suspend the other coins, so later we will pay with the recouped coin
taler-wallet-cli $TIMETRAVEL --wallet-db=$WALLET_DB advanced suspend-coins "$susp"
# Update exchange /keys so recoup gets scheduled
taler-wallet-cli $TIMETRAVEL --wallet-db=$WALLET_DB exchanges update \
-f $EXCHANGE_URL
# Block until scheduled operations are done
2020-03-27 18:10:59 +01:00
taler-wallet-cli $TIMETRAVEL --wallet-db=$WALLET_DB run-until-done
2020-03-26 17:21:41 +01:00
2020-03-26 18:58:42 +01:00
echo "Restarting merchant (so new keys are known)"
kill -TERM $MERCHANT_PID
2022-09-22 21:37:26 +02:00
taler-merchant-httpd -c $CONF -L INFO 2> ${MY_TMP_DIR}/taler-merchant-httpd.log &
2020-03-26 18:58:42 +01:00
MERCHANT_PID=$!
# Wait for merchant to be again available
for n in `seq 1 50`
do
echo -n "."
sleep 0.1
OK=0
# merchant
wget http://localhost:9966/ -o /dev/null -O /dev/null >/dev/null || continue
OK=1
break
done
2020-03-26 17:21:41 +01:00
# Now we buy something, only the coins resulting from recoup+refresh will be
# used, as other ones are suspended
2020-08-29 13:22:16 +02:00
taler-wallet-cli $TIMETRAVEL --no-throttle --wallet-db=$WALLET_DB api 'testPay' \
"$(jq -n '
{
amount: "TESTKUDOS:0.02",
merchantBaseUrl: $MERCHANT_URL,
summary: "bar",
}' \
--arg MERCHANT_URL $MERCHANT_URL
)"
2020-03-26 17:21:41 +01:00
taler-wallet-cli $TIMETRAVEL --wallet-db=$WALLET_DB run-until-done
echo "Bought something with refresh-recouped coin"
echo "Shutting down services"
2022-09-21 18:04:34 +02:00
exit_cleanup
2020-03-26 17:21:41 +01:00
# Dump database
echo "Dumping database"
2022-08-06 13:25:54 +02:00
echo "Dumping PostgreSQL database: ${BASEDB}.sql"
2020-03-26 17:21:41 +01:00
pg_dump -O $TARGET_DB | sed -e '/AS integer/d' > ${BASEDB}.sql
2022-08-06 13:25:54 +02:00
echo "Dumping libeufin database: ${BASEDB}-libeufin.sql"
2022-09-21 18:04:34 +02:00
sqlite3 ${TARGET_DB}-nexus.sqlite3 ".dump" > ${BASEDB}-libeufin-nexus.sql
sqlite3 ${TARGET_DB}-sandbox.sqlite3 ".dump" > ${BASEDB}-libeufin-sandbox.sql
2020-03-26 17:21:41 +01:00
echo $MASTER_PUB > ${BASEDB}.mpub
# clean up
2020-08-29 13:39:57 +02:00
echo "Final clean up"
2020-03-26 17:21:41 +01:00
dropdb $TARGET_DB
2022-09-21 18:04:34 +02:00
rm ${TARGET_DB}-sandbox.sqlite3 ${TARGET_DB}-nexus.sqlite3 # libeufin DB
2020-03-26 17:21:41 +01:00
echo "====================================="
2022-09-19 19:32:18 +02:00
echo " Finished generation of $BASEDB "
2020-03-26 17:21:41 +01:00
echo "====================================="
exit 0